/* sudoku-view.c generated by valac 0.56.17, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;

#define TYPE_SUDOKU_FRAME (sudoku_frame_get_type ())
#define SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_FRAME, SudokuFrame))
#define SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_FRAME, SudokuFrameClass))
#define IS_SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_FRAME))
#define IS_SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_FRAME))
#define SUDOKU_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_FRAME, SudokuFrameClass))

typedef struct _SudokuFrame SudokuFrame;
typedef struct _SudokuFrameClass SudokuFrameClass;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_SELECTED_ROW_PROPERTY,
	SUDOKU_VIEW_SELECTED_COL_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_HAS_SELECTION_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL,
	SUDOKU_VIEW_NUM_SIGNALS
};
static guint sudoku_view_signals[SUDOKU_VIEW_NUM_SIGNALS] = {0};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

struct _SudokuViewPrivate {
	SudokuGame* game;
	SudokuCell** cells;
	gint cells_length1;
	gint cells_length2;
	SudokuFrame* frame;
	GtkLabel* paused_label;
	gint _selected_row;
	gint _selected_col;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean _show_possibilities;
	gboolean _highlighter;
	gboolean _has_selection;
};

static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN GType sudoku_frame_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuFrame, g_object_unref)
VALA_EXTERN void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN gint sudoku_view_get_selected_row (SudokuView* self);
VALA_EXTERN gint sudoku_view_get_selected_col (SudokuView* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
static void sudoku_view_set_selected_row (SudokuView* self,
                                   gint value);
static void sudoku_view_set_selected_col (SudokuView* self,
                                   gint value);
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game,
                             GSettings* settings);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game,
                                   GSettings* settings);
VALA_EXTERN SudokuFrame* sudoku_frame_new (GtkWidget* child);
VALA_EXTERN SudokuFrame* sudoku_frame_construct (GType object_type,
                                     GtkWidget* child);
static void __lambda8_ (SudokuView* self);
static void sudoku_view_mask_view (SudokuView* self);
static void sudoku_view_clear_all_warnings (SudokuView* self);
static void sudoku_view_unmask_view (SudokuView* self);
static void sudoku_view_update_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda8__sudoku_game_paused_changed (SudokuGame* _sender,
                                             gpointer self);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame* game,
                             SudokuView* view);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame* game,
                                   SudokuView* view);
VALA_EXTERN void sudoku_cell_initialize_earmarks (SudokuCell* self,
                                      gboolean show_possibilities,
                                      gboolean force);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
static void sudoku_view_cell_changed_cb (SudokuView* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val);
static void _sudoku_view_cell_changed_cb_sudoku_board_cell_changed (SudokuBoard* _sender,
                                                             gint row,
                                                             gint col,
                                                             gint old_val,
                                                             gint new_val,
                                                             gpointer self);
static void sudoku_view_earmark_changed_cb (SudokuView* self,
                                     gint row,
                                     gint col,
                                     gint num,
                                     gboolean enabled);
static void _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                                   gint row,
                                                                   gint col,
                                                                   gint num,
                                                                   gboolean enabled,
                                                                   gpointer self);
static void sudoku_view_selection_changed_cb (SudokuView* self,
                                       gint old_row,
                                       gint old_col,
                                       gint new_row,
                                       gint new_col);
static void _sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                      gint old_row,
                                                                      gint old_col,
                                                                      gint new_row,
                                                                      gint new_col,
                                                                      gpointer self);
static void sudoku_view_set_cell_highlighter (SudokuView* self,
                                       gint row,
                                       gint col,
                                       gboolean enabled);
VALA_EXTERN void sudoku_cell_dismiss_popover (SudokuCell* self);
VALA_EXTERN void sudoku_cell_update_value (SudokuCell* self);
static void sudoku_view_set_value_highlighter (SudokuView* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN void sudoku_cell_update_earmark (SudokuCell* self,
                                 gint num);
VALA_EXTERN void sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                         gint num);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_check_value_warnings (SudokuCell* self,
                                       gboolean show_extra_warnings);
VALA_EXTERN gboolean sudoku_view_get_show_extra_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_check_earmarks_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_view_clear (SudokuView* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_paused (SudokuCell* self,
                             gboolean value);
VALA_EXTERN void sudoku_view_dismiss_popovers (SudokuView* self);
static void sudoku_view_real_dispose (GObject* base);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN void sudoku_view_set_show_extra_warnings (SudokuView* self,
                                          gboolean value);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
VALA_EXTERN gboolean sudoku_view_get_has_selection (SudokuView* self);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static gboolean _sudoku_view___lambda9_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda9__gtk_shortcut_func (GtkWidget* widget,
                                                     GVariant* args,
                                                     gpointer self);
static gboolean _sudoku_view___lambda10_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda10__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda11_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda11__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda12_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda12__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	gint old_row = 0;
	gint _tmp10_;
	gint old_col = 0;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_ = FALSE;
	gint _tmp15_;
#line 38 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 40 "../src/sudoku-view.vala"
	if (_tmp1_ == cell_row) {
#line 323 "sudoku-view.c"
		gint _tmp2_;
#line 40 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->_selected_col;
#line 40 "../src/sudoku-view.vala"
		_tmp0_ = _tmp2_ == cell_col;
#line 329 "sudoku-view.c"
	} else {
#line 40 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 333 "sudoku-view.c"
	}
#line 40 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 41 "../src/sudoku-view.vala"
		return;
#line 339 "sudoku-view.c"
	}
#line 43 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->_selected_row;
#line 43 "../src/sudoku-view.vala"
	if (_tmp4_ >= 0) {
#line 345 "sudoku-view.c"
		gint _tmp5_;
#line 43 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->_selected_col;
#line 43 "../src/sudoku-view.vala"
		_tmp3_ = _tmp5_ >= 0;
#line 351 "sudoku-view.c"
	} else {
#line 43 "../src/sudoku-view.vala"
		_tmp3_ = FALSE;
#line 355 "sudoku-view.c"
	}
#line 43 "../src/sudoku-view.vala"
	if (_tmp3_) {
#line 359 "sudoku-view.c"
		SudokuCell** _tmp6_;
		gint _tmp6__length1;
		gint _tmp6__length2;
		gint _tmp7_;
		gint _tmp8_;
		SudokuCell* _tmp9_;
#line 44 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->cells;
#line 44 "../src/sudoku-view.vala"
		_tmp6__length1 = self->priv->cells_length1;
#line 44 "../src/sudoku-view.vala"
		_tmp6__length2 = self->priv->cells_length2;
#line 44 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->_selected_row;
#line 44 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->_selected_col;
#line 44 "../src/sudoku-view.vala"
		_tmp9_ = _tmp6_[(_tmp7_ * _tmp6__length2) + _tmp8_];
#line 44 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp9_, FALSE);
#line 380 "sudoku-view.c"
	}
#line 46 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->_selected_row;
#line 46 "../src/sudoku-view.vala"
	old_row = _tmp10_;
#line 47 "../src/sudoku-view.vala"
	_tmp11_ = self->priv->_selected_col;
#line 47 "../src/sudoku-view.vala"
	old_col = _tmp11_;
#line 49 "../src/sudoku-view.vala"
	sudoku_view_set_selected_row (self, cell_row);
#line 50 "../src/sudoku-view.vala"
	sudoku_view_set_selected_col (self, cell_col);
#line 52 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->_selected_row;
#line 52 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->_selected_col;
#line 52 "../src/sudoku-view.vala"
	g_signal_emit (self, sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL], 0, old_row, old_col, _tmp12_, _tmp13_);
#line 54 "../src/sudoku-view.vala"
	_tmp15_ = self->priv->_selected_row;
#line 54 "../src/sudoku-view.vala"
	if (_tmp15_ >= 0) {
#line 404 "sudoku-view.c"
		gint _tmp16_;
#line 54 "../src/sudoku-view.vala"
		_tmp16_ = self->priv->_selected_col;
#line 54 "../src/sudoku-view.vala"
		_tmp14_ = _tmp16_ >= 0;
#line 410 "sudoku-view.c"
	} else {
#line 54 "../src/sudoku-view.vala"
		_tmp14_ = FALSE;
#line 414 "sudoku-view.c"
	}
#line 54 "../src/sudoku-view.vala"
	if (_tmp14_) {
#line 418 "sudoku-view.c"
		SudokuCell** _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		gint _tmp18_;
		gint _tmp19_;
		SudokuCell* _tmp20_;
#line 55 "../src/sudoku-view.vala"
		_tmp17_ = self->priv->cells;
#line 55 "../src/sudoku-view.vala"
		_tmp17__length1 = self->priv->cells_length1;
#line 55 "../src/sudoku-view.vala"
		_tmp17__length2 = self->priv->cells_length2;
#line 55 "../src/sudoku-view.vala"
		_tmp18_ = self->priv->_selected_row;
#line 55 "../src/sudoku-view.vala"
		_tmp19_ = self->priv->_selected_col;
#line 55 "../src/sudoku-view.vala"
		_tmp20_ = _tmp17_[(_tmp18_ * _tmp17__length2) + _tmp19_];
#line 55 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp20_, TRUE);
#line 439 "sudoku-view.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 60 "../src/sudoku-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 448 "sudoku-view.c"
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 85 "../src/sudoku-view.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 456 "sudoku-view.c"
}

static void
__lambda8_ (SudokuView* self)
{
	PangoAttrList* attr_list = NULL;
	GtkLabel* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp3_;
	PangoAttrList* _tmp5_;
	PangoAttribute* _tmp6_;
	GtkLabel* _tmp7_;
	PangoAttrList* _tmp8_;
	GtkLabel* _tmp9_;
	SudokuGame* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	SudokuGame* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	SudokuGame* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
#line 85 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->paused_label;
#line 85 "../src/sudoku-view.vala"
	_tmp1_ = gtk_label_get_attributes (_tmp0_);
#line 85 "../src/sudoku-view.vala"
	_tmp2_ = _pango_attr_list_ref0 (_tmp1_);
#line 85 "../src/sudoku-view.vala"
	attr_list = _tmp2_;
#line 86 "../src/sudoku-view.vala"
	_tmp3_ = attr_list;
#line 86 "../src/sudoku-view.vala"
	if (_tmp3_ == NULL) {
#line 493 "sudoku-view.c"
		PangoAttrList* _tmp4_;
#line 87 "../src/sudoku-view.vala"
		_tmp4_ = pango_attr_list_new ();
#line 87 "../src/sudoku-view.vala"
		_pango_attr_list_unref0 (attr_list);
#line 87 "../src/sudoku-view.vala"
		attr_list = _tmp4_;
#line 501 "sudoku-view.c"
	}
#line 89 "../src/sudoku-view.vala"
	_tmp5_ = attr_list;
#line 89 "../src/sudoku-view.vala"
	_tmp6_ = pango_attr_size_new_absolute (((gint) (gtk_widget_get_width ((GtkWidget*) self) * 0.125)) * PANGO_SCALE);
#line 89 "../src/sudoku-view.vala"
	pango_attr_list_change (_tmp5_, _tmp6_);
#line 93 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->paused_label;
#line 93 "../src/sudoku-view.vala"
	_tmp8_ = attr_list;
#line 93 "../src/sudoku-view.vala"
	gtk_label_set_attributes (_tmp7_, _tmp8_);
#line 94 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->paused_label;
#line 94 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->game;
#line 94 "../src/sudoku-view.vala"
	_tmp11_ = sudoku_game_get_paused (_tmp10_);
#line 94 "../src/sudoku-view.vala"
	_tmp12_ = _tmp11_;
#line 94 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, _tmp12_);
#line 96 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->game;
#line 96 "../src/sudoku-view.vala"
	_tmp14_ = sudoku_game_get_paused (_tmp13_);
#line 96 "../src/sudoku-view.vala"
	_tmp15_ = _tmp14_;
#line 96 "../src/sudoku-view.vala"
	if (_tmp15_) {
#line 98 "../src/sudoku-view.vala"
		sudoku_view_mask_view (self);
#line 99 "../src/sudoku-view.vala"
		sudoku_view_clear_all_warnings (self);
#line 537 "sudoku-view.c"
	} else {
#line 103 "../src/sudoku-view.vala"
		sudoku_view_unmask_view (self);
#line 104 "../src/sudoku-view.vala"
		sudoku_view_update_warnings (self);
#line 543 "sudoku-view.c"
	}
#line 107 "../src/sudoku-view.vala"
	_tmp16_ = self->priv->game;
#line 107 "../src/sudoku-view.vala"
	_tmp17_ = sudoku_game_get_paused (_tmp16_);
#line 107 "../src/sudoku-view.vala"
	_tmp18_ = _tmp17_;
#line 107 "../src/sudoku-view.vala"
	sudoku_view_set_has_selection (self, !_tmp18_);
#line 83 "../src/sudoku-view.vala"
	_pango_attr_list_unref0 (attr_list);
#line 555 "sudoku-view.c"
}

static void
___lambda8__sudoku_game_paused_changed (SudokuGame* _sender,
                                        gpointer self)
{
#line 83 "../src/sudoku-view.vala"
	__lambda8_ ((SudokuView*) self);
#line 564 "sudoku-view.c"
}

static void
_sudoku_view_cell_changed_cb_sudoku_board_cell_changed (SudokuBoard* _sender,
                                                        gint row,
                                                        gint col,
                                                        gint old_val,
                                                        gint new_val,
                                                        gpointer self)
{
#line 151 "../src/sudoku-view.vala"
	sudoku_view_cell_changed_cb ((SudokuView*) self, row, col, old_val, new_val);
#line 577 "sudoku-view.c"
}

static void
_sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                              gint row,
                                                              gint col,
                                                              gint num,
                                                              gboolean enabled,
                                                              gpointer self)
{
#line 152 "../src/sudoku-view.vala"
	sudoku_view_earmark_changed_cb ((SudokuView*) self, row, col, num, enabled);
#line 590 "sudoku-view.c"
}

static void
_sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                 gint old_row,
                                                                 gint old_col,
                                                                 gint new_row,
                                                                 gint new_col,
                                                                 gpointer self)
{
#line 153 "../src/sudoku-view.vala"
	sudoku_view_selection_changed_cb ((SudokuView*) self, old_row, old_col, new_row, new_col);
#line 603 "sudoku-view.c"
}

SudokuView*
sudoku_view_construct (GType object_type,
                       SudokuGame* game,
                       GSettings* settings)
{
	SudokuView * self = NULL;
	SudokuGame* _tmp0_;
	GameMode _tmp1_;
	GameMode _tmp2_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp3_;
	GtkOverlay* _tmp4_;
	SudokuFrame* _tmp5_;
	SudokuFrame* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkOverlay* _tmp10_;
	GtkLabel* _tmp11_;
	SudokuGame* _tmp12_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp13_ = NULL;
	GtkGrid* _tmp14_;
	GtkOverlay* _tmp15_;
	GtkGrid* _tmp16_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp17_;
	SudokuBoard* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	SudokuBoard* _tmp21_;
	SudokuBoard* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	GtkGrid** _tmp25_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp49_;
	SudokuBoard* _tmp50_;
	gint _tmp51_;
	gint _tmp52_;
	SudokuBoard* _tmp53_;
	SudokuBoard* _tmp54_;
	gint _tmp55_;
	gint _tmp56_;
	SudokuCell** _tmp57_;
	SudokuGame* _tmp96_;
	SudokuBoard* _tmp97_;
	SudokuBoard* _tmp98_;
	SudokuGame* _tmp99_;
	SudokuBoard* _tmp100_;
	SudokuBoard* _tmp101_;
#line 58 "../src/sudoku-view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 58 "../src/sudoku-view.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 58 "../src/sudoku-view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 60 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 60 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->game);
#line 60 "../src/sudoku-view.vala"
	self->priv->game = _tmp0_;
#line 62 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 63 "../src/sudoku-view.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 64 "../src/sudoku-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 66 "../src/sudoku-view.vala"
	_tmp1_ = sudoku_game_get_mode (game);
#line 66 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 66 "../src/sudoku-view.vala"
	if (_tmp2_ == GAME_MODE_CREATE) {
#line 67 "../src/sudoku-view.vala"
		self->priv->_show_warnings = TRUE;
#line 684 "sudoku-view.c"
	} else {
#line 69 "../src/sudoku-view.vala"
		self->priv->_show_warnings = g_settings_get_boolean (settings, "show-warnings");
#line 688 "sudoku-view.c"
	}
#line 70 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = g_settings_get_boolean (settings, "show-possibilities");
#line 71 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = g_settings_get_boolean (settings, "show-extra-warnings");
#line 72 "../src/sudoku-view.vala"
	self->priv->_highlighter = g_settings_get_boolean (settings, "highlighter");
#line 74 "../src/sudoku-view.vala"
	_tmp3_ = (GtkOverlay*) gtk_overlay_new ();
#line 74 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 74 "../src/sudoku-view.vala"
	overlay = _tmp3_;
#line 75 "../src/sudoku-view.vala"
	_tmp4_ = overlay;
#line 75 "../src/sudoku-view.vala"
	_tmp5_ = sudoku_frame_new ((GtkWidget*) _tmp4_);
#line 75 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp5_);
#line 75 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->frame);
#line 75 "../src/sudoku-view.vala"
	self->priv->frame = _tmp5_;
#line 76 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->frame;
#line 76 "../src/sudoku-view.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp6_);
#line 78 "../src/sudoku-view.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new ("Paused");
#line 78 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp7_);
#line 78 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused_label);
#line 78 "../src/sudoku-view.vala"
	self->priv->paused_label = _tmp7_;
#line 79 "../src/sudoku-view.vala"
	_tmp8_ = self->priv->paused_label;
#line 79 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "paused");
#line 80 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->paused_label;
#line 80 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 81 "../src/sudoku-view.vala"
	_tmp10_ = overlay;
#line 81 "../src/sudoku-view.vala"
	_tmp11_ = self->priv->paused_label;
#line 81 "../src/sudoku-view.vala"
	gtk_overlay_add_overlay (_tmp10_, (GtkWidget*) _tmp11_);
#line 83 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->game;
#line 83 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp12_, "paused-changed", (GCallback) ___lambda8__sudoku_game_paused_changed, self, 0);
#line 110 "../src/sudoku-view.vala"
	_tmp13_ = (GtkGrid*) gtk_grid_new ();
#line 110 "../src/sudoku-view.vala"
	gtk_grid_set_row_spacing (_tmp13_, 2);
#line 110 "../src/sudoku-view.vala"
	gtk_grid_set_column_spacing (_tmp13_, 2);
#line 110 "../src/sudoku-view.vala"
	gtk_grid_set_column_homogeneous (_tmp13_, TRUE);
#line 110 "../src/sudoku-view.vala"
	gtk_grid_set_row_homogeneous (_tmp13_, TRUE);
#line 110 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp13_, TRUE);
#line 110 "../src/sudoku-view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
#line 110 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp13_);
#line 110 "../src/sudoku-view.vala"
	grid = _tmp13_;
#line 118 "../src/sudoku-view.vala"
	_tmp14_ = grid;
#line 118 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp14_, "board");
#line 119 "../src/sudoku-view.vala"
	_tmp15_ = overlay;
#line 119 "../src/sudoku-view.vala"
	_tmp16_ = grid;
#line 119 "../src/sudoku-view.vala"
	gtk_overlay_set_child (_tmp15_, (GtkWidget*) _tmp16_);
#line 121 "../src/sudoku-view.vala"
	_tmp17_ = sudoku_game_get_board (game);
#line 121 "../src/sudoku-view.vala"
	_tmp18_ = _tmp17_;
#line 121 "../src/sudoku-view.vala"
	_tmp19_ = sudoku_board_get_block_rows (_tmp18_);
#line 121 "../src/sudoku-view.vala"
	_tmp20_ = _tmp19_;
#line 121 "../src/sudoku-view.vala"
	_tmp21_ = sudoku_game_get_board (game);
#line 121 "../src/sudoku-view.vala"
	_tmp22_ = _tmp21_;
#line 121 "../src/sudoku-view.vala"
	_tmp23_ = sudoku_board_get_block_cols (_tmp22_);
#line 121 "../src/sudoku-view.vala"
	_tmp24_ = _tmp23_;
#line 121 "../src/sudoku-view.vala"
	_tmp25_ = g_new0 (GtkGrid*, (_tmp20_ * _tmp24_) + 1);
#line 121 "../src/sudoku-view.vala"
	blocks = _tmp25_;
#line 121 "../src/sudoku-view.vala"
	blocks_length1 = _tmp20_;
#line 121 "../src/sudoku-view.vala"
	blocks_length2 = _tmp24_;
#line 794 "sudoku-view.c"
	{
		gint block_row = 0;
#line 122 "../src/sudoku-view.vala"
		block_row = 0;
#line 799 "sudoku-view.c"
		{
			gboolean _tmp26_ = FALSE;
#line 122 "../src/sudoku-view.vala"
			_tmp26_ = TRUE;
#line 122 "../src/sudoku-view.vala"
			while (TRUE) {
#line 806 "sudoku-view.c"
				SudokuBoard* _tmp28_;
				SudokuBoard* _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
#line 122 "../src/sudoku-view.vala"
				if (!_tmp26_) {
#line 813 "sudoku-view.c"
					gint _tmp27_;
#line 122 "../src/sudoku-view.vala"
					_tmp27_ = block_row;
#line 122 "../src/sudoku-view.vala"
					block_row = _tmp27_ + 1;
#line 819 "sudoku-view.c"
				}
#line 122 "../src/sudoku-view.vala"
				_tmp26_ = FALSE;
#line 122 "../src/sudoku-view.vala"
				_tmp28_ = sudoku_game_get_board (game);
#line 122 "../src/sudoku-view.vala"
				_tmp29_ = _tmp28_;
#line 122 "../src/sudoku-view.vala"
				_tmp30_ = sudoku_board_get_block_rows (_tmp29_);
#line 122 "../src/sudoku-view.vala"
				_tmp31_ = _tmp30_;
#line 122 "../src/sudoku-view.vala"
				if (!(block_row < _tmp31_)) {
#line 122 "../src/sudoku-view.vala"
					break;
#line 835 "sudoku-view.c"
				}
				{
					gint block_col = 0;
#line 124 "../src/sudoku-view.vala"
					block_col = 0;
#line 841 "sudoku-view.c"
					{
						gboolean _tmp32_ = FALSE;
#line 124 "../src/sudoku-view.vala"
						_tmp32_ = TRUE;
#line 124 "../src/sudoku-view.vala"
						while (TRUE) {
#line 848 "sudoku-view.c"
							SudokuBoard* _tmp34_;
							SudokuBoard* _tmp35_;
							gint _tmp36_;
							gint _tmp37_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp38_;
							GtkGrid* _tmp39_;
							GtkGrid* _tmp40_;
							GtkGrid* _tmp41_;
							GtkGrid* _tmp42_;
							GtkGrid* _tmp43_;
							GtkGrid* _tmp44_;
							GtkGrid* _tmp45_;
							GtkGrid** _tmp46_;
							gint _tmp46__length1;
							gint _tmp46__length2;
							GtkGrid* _tmp47_;
							GtkGrid* _tmp48_;
#line 124 "../src/sudoku-view.vala"
							if (!_tmp32_) {
#line 869 "sudoku-view.c"
								gint _tmp33_;
#line 124 "../src/sudoku-view.vala"
								_tmp33_ = block_col;
#line 124 "../src/sudoku-view.vala"
								block_col = _tmp33_ + 1;
#line 875 "sudoku-view.c"
							}
#line 124 "../src/sudoku-view.vala"
							_tmp32_ = FALSE;
#line 124 "../src/sudoku-view.vala"
							_tmp34_ = sudoku_game_get_board (game);
#line 124 "../src/sudoku-view.vala"
							_tmp35_ = _tmp34_;
#line 124 "../src/sudoku-view.vala"
							_tmp36_ = sudoku_board_get_block_cols (_tmp35_);
#line 124 "../src/sudoku-view.vala"
							_tmp37_ = _tmp36_;
#line 124 "../src/sudoku-view.vala"
							if (!(block_col < _tmp37_)) {
#line 124 "../src/sudoku-view.vala"
								break;
#line 891 "sudoku-view.c"
							}
#line 126 "../src/sudoku-view.vala"
							_tmp38_ = (GtkGrid*) gtk_grid_new ();
#line 126 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp38_);
#line 126 "../src/sudoku-view.vala"
							block_grid = _tmp38_;
#line 127 "../src/sudoku-view.vala"
							_tmp39_ = block_grid;
#line 127 "../src/sudoku-view.vala"
							gtk_grid_set_row_spacing (_tmp39_, 1);
#line 128 "../src/sudoku-view.vala"
							_tmp40_ = block_grid;
#line 128 "../src/sudoku-view.vala"
							gtk_grid_set_column_spacing (_tmp40_, 1);
#line 129 "../src/sudoku-view.vala"
							_tmp41_ = block_grid;
#line 129 "../src/sudoku-view.vala"
							gtk_grid_set_column_homogeneous (_tmp41_, TRUE);
#line 130 "../src/sudoku-view.vala"
							_tmp42_ = block_grid;
#line 130 "../src/sudoku-view.vala"
							gtk_grid_set_row_homogeneous (_tmp42_, TRUE);
#line 131 "../src/sudoku-view.vala"
							_tmp43_ = block_grid;
#line 131 "../src/sudoku-view.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp43_, "block");
#line 132 "../src/sudoku-view.vala"
							_tmp44_ = grid;
#line 132 "../src/sudoku-view.vala"
							_tmp45_ = block_grid;
#line 132 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp45_, block_col, block_row, 1, 1);
#line 134 "../src/sudoku-view.vala"
							_tmp46_ = blocks;
#line 134 "../src/sudoku-view.vala"
							_tmp46__length1 = blocks_length1;
#line 134 "../src/sudoku-view.vala"
							_tmp46__length2 = blocks_length2;
#line 134 "../src/sudoku-view.vala"
							_tmp47_ = block_grid;
#line 134 "../src/sudoku-view.vala"
							_tmp48_ = _g_object_ref0 (_tmp47_);
#line 134 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp46_[(block_row * _tmp46__length2) + block_col]);
#line 134 "../src/sudoku-view.vala"
							_tmp46_[(block_row * _tmp46__length2) + block_col] = _tmp48_;
#line 124 "../src/sudoku-view.vala"
							_g_object_unref0 (block_grid);
#line 941 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 138 "../src/sudoku-view.vala"
	_tmp49_ = sudoku_game_get_board (game);
#line 138 "../src/sudoku-view.vala"
	_tmp50_ = _tmp49_;
#line 138 "../src/sudoku-view.vala"
	_tmp51_ = sudoku_board_get_rows (_tmp50_);
#line 138 "../src/sudoku-view.vala"
	_tmp52_ = _tmp51_;
#line 138 "../src/sudoku-view.vala"
	_tmp53_ = sudoku_game_get_board (game);
#line 138 "../src/sudoku-view.vala"
	_tmp54_ = _tmp53_;
#line 138 "../src/sudoku-view.vala"
	_tmp55_ = sudoku_board_get_cols (_tmp54_);
#line 138 "../src/sudoku-view.vala"
	_tmp56_ = _tmp55_;
#line 138 "../src/sudoku-view.vala"
	_tmp57_ = g_new0 (SudokuCell*, (_tmp52_ * _tmp56_) + 1);
#line 138 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 138 "../src/sudoku-view.vala"
	self->priv->cells = _tmp57_;
#line 138 "../src/sudoku-view.vala"
	self->priv->cells_length1 = _tmp52_;
#line 138 "../src/sudoku-view.vala"
	self->priv->cells_length2 = _tmp56_;
#line 974 "sudoku-view.c"
	{
		gint row = 0;
#line 139 "../src/sudoku-view.vala"
		row = 0;
#line 979 "sudoku-view.c"
		{
			gboolean _tmp58_ = FALSE;
#line 139 "../src/sudoku-view.vala"
			_tmp58_ = TRUE;
#line 139 "../src/sudoku-view.vala"
			while (TRUE) {
#line 986 "sudoku-view.c"
				SudokuBoard* _tmp60_;
				SudokuBoard* _tmp61_;
				gint _tmp62_;
				gint _tmp63_;
#line 139 "../src/sudoku-view.vala"
				if (!_tmp58_) {
#line 993 "sudoku-view.c"
					gint _tmp59_;
#line 139 "../src/sudoku-view.vala"
					_tmp59_ = row;
#line 139 "../src/sudoku-view.vala"
					row = _tmp59_ + 1;
#line 999 "sudoku-view.c"
				}
#line 139 "../src/sudoku-view.vala"
				_tmp58_ = FALSE;
#line 139 "../src/sudoku-view.vala"
				_tmp60_ = sudoku_game_get_board (game);
#line 139 "../src/sudoku-view.vala"
				_tmp61_ = _tmp60_;
#line 139 "../src/sudoku-view.vala"
				_tmp62_ = sudoku_board_get_rows (_tmp61_);
#line 139 "../src/sudoku-view.vala"
				_tmp63_ = _tmp62_;
#line 139 "../src/sudoku-view.vala"
				if (!(row < _tmp63_)) {
#line 139 "../src/sudoku-view.vala"
					break;
#line 1015 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 141 "../src/sudoku-view.vala"
					col = 0;
#line 1021 "sudoku-view.c"
					{
						gboolean _tmp64_ = FALSE;
#line 141 "../src/sudoku-view.vala"
						_tmp64_ = TRUE;
#line 141 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1028 "sudoku-view.c"
							SudokuBoard* _tmp66_;
							SudokuBoard* _tmp67_;
							gint _tmp68_;
							gint _tmp69_;
							SudokuCell* cell = NULL;
							SudokuCell* _tmp70_;
							SudokuCell* _tmp71_;
							gboolean _tmp72_;
							gboolean _tmp73_;
							GtkGrid** _tmp74_;
							gint _tmp74__length1;
							gint _tmp74__length2;
							SudokuBoard* _tmp75_;
							SudokuBoard* _tmp76_;
							gint _tmp77_;
							gint _tmp78_;
							SudokuBoard* _tmp79_;
							SudokuBoard* _tmp80_;
							gint _tmp81_;
							gint _tmp82_;
							GtkGrid* _tmp83_;
							SudokuCell* _tmp84_;
							SudokuBoard* _tmp85_;
							SudokuBoard* _tmp86_;
							gint _tmp87_;
							gint _tmp88_;
							SudokuBoard* _tmp89_;
							SudokuBoard* _tmp90_;
							gint _tmp91_;
							gint _tmp92_;
							SudokuCell** _tmp93_;
							gint _tmp93__length1;
							gint _tmp93__length2;
							SudokuCell* _tmp94_;
							SudokuCell* _tmp95_;
#line 141 "../src/sudoku-view.vala"
							if (!_tmp64_) {
#line 1066 "sudoku-view.c"
								gint _tmp65_;
#line 141 "../src/sudoku-view.vala"
								_tmp65_ = col;
#line 141 "../src/sudoku-view.vala"
								col = _tmp65_ + 1;
#line 1072 "sudoku-view.c"
							}
#line 141 "../src/sudoku-view.vala"
							_tmp64_ = FALSE;
#line 141 "../src/sudoku-view.vala"
							_tmp66_ = sudoku_game_get_board (game);
#line 141 "../src/sudoku-view.vala"
							_tmp67_ = _tmp66_;
#line 141 "../src/sudoku-view.vala"
							_tmp68_ = sudoku_board_get_cols (_tmp67_);
#line 141 "../src/sudoku-view.vala"
							_tmp69_ = _tmp68_;
#line 141 "../src/sudoku-view.vala"
							if (!(col < _tmp69_)) {
#line 141 "../src/sudoku-view.vala"
								break;
#line 1088 "sudoku-view.c"
							}
#line 144 "../src/sudoku-view.vala"
							_tmp70_ = sudoku_cell_new (row, col, game, self);
#line 144 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp70_);
#line 144 "../src/sudoku-view.vala"
							cell = _tmp70_;
#line 145 "../src/sudoku-view.vala"
							_tmp71_ = cell;
#line 145 "../src/sudoku-view.vala"
							_tmp72_ = sudoku_view_get_show_possibilities (self);
#line 145 "../src/sudoku-view.vala"
							_tmp73_ = _tmp72_;
#line 145 "../src/sudoku-view.vala"
							sudoku_cell_initialize_earmarks (_tmp71_, _tmp73_, FALSE);
#line 146 "../src/sudoku-view.vala"
							_tmp74_ = blocks;
#line 146 "../src/sudoku-view.vala"
							_tmp74__length1 = blocks_length1;
#line 146 "../src/sudoku-view.vala"
							_tmp74__length2 = blocks_length2;
#line 146 "../src/sudoku-view.vala"
							_tmp75_ = sudoku_game_get_board (game);
#line 146 "../src/sudoku-view.vala"
							_tmp76_ = _tmp75_;
#line 146 "../src/sudoku-view.vala"
							_tmp77_ = sudoku_board_get_block_rows (_tmp76_);
#line 146 "../src/sudoku-view.vala"
							_tmp78_ = _tmp77_;
#line 146 "../src/sudoku-view.vala"
							_tmp79_ = sudoku_game_get_board (game);
#line 146 "../src/sudoku-view.vala"
							_tmp80_ = _tmp79_;
#line 146 "../src/sudoku-view.vala"
							_tmp81_ = sudoku_board_get_block_cols (_tmp80_);
#line 146 "../src/sudoku-view.vala"
							_tmp82_ = _tmp81_;
#line 146 "../src/sudoku-view.vala"
							_tmp83_ = _tmp74_[((row / _tmp78_) * _tmp74__length2) + (col / _tmp82_)];
#line 146 "../src/sudoku-view.vala"
							_tmp84_ = cell;
#line 146 "../src/sudoku-view.vala"
							_tmp85_ = sudoku_game_get_board (game);
#line 146 "../src/sudoku-view.vala"
							_tmp86_ = _tmp85_;
#line 146 "../src/sudoku-view.vala"
							_tmp87_ = sudoku_board_get_block_cols (_tmp86_);
#line 146 "../src/sudoku-view.vala"
							_tmp88_ = _tmp87_;
#line 146 "../src/sudoku-view.vala"
							_tmp89_ = sudoku_game_get_board (game);
#line 146 "../src/sudoku-view.vala"
							_tmp90_ = _tmp89_;
#line 146 "../src/sudoku-view.vala"
							_tmp91_ = sudoku_board_get_block_rows (_tmp90_);
#line 146 "../src/sudoku-view.vala"
							_tmp92_ = _tmp91_;
#line 146 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp83_, (GtkWidget*) _tmp84_, col % _tmp88_, row % _tmp92_, 1, 1);
#line 147 "../src/sudoku-view.vala"
							_tmp93_ = self->priv->cells;
#line 147 "../src/sudoku-view.vala"
							_tmp93__length1 = self->priv->cells_length1;
#line 147 "../src/sudoku-view.vala"
							_tmp93__length2 = self->priv->cells_length2;
#line 147 "../src/sudoku-view.vala"
							_tmp94_ = cell;
#line 147 "../src/sudoku-view.vala"
							_tmp95_ = _g_object_ref0 (_tmp94_);
#line 147 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp93_[(row * _tmp93__length2) + col]);
#line 147 "../src/sudoku-view.vala"
							_tmp93_[(row * _tmp93__length2) + col] = _tmp95_;
#line 141 "../src/sudoku-view.vala"
							_g_object_unref0 (cell);
#line 1164 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 151 "../src/sudoku-view.vala"
	_tmp96_ = self->priv->game;
#line 151 "../src/sudoku-view.vala"
	_tmp97_ = sudoku_game_get_board (_tmp96_);
#line 151 "../src/sudoku-view.vala"
	_tmp98_ = _tmp97_;
#line 151 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp98_, "cell-changed", (GCallback) _sudoku_view_cell_changed_cb_sudoku_board_cell_changed, self, 0);
#line 152 "../src/sudoku-view.vala"
	_tmp99_ = self->priv->game;
#line 152 "../src/sudoku-view.vala"
	_tmp100_ = sudoku_game_get_board (_tmp99_);
#line 152 "../src/sudoku-view.vala"
	_tmp101_ = _tmp100_;
#line 152 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp101_, "earmark-changed", (GCallback) _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed, self, 0);
#line 153 "../src/sudoku-view.vala"
	g_signal_connect_object (self, "selection-changed", (GCallback) _sudoku_view_selection_changed_cb_sudoku_view_selection_changed, self, 0);
#line 155 "../src/sudoku-view.vala"
	sudoku_view_update_warnings (self);
#line 58 "../src/sudoku-view.vala"
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 58 "../src/sudoku-view.vala"
	_g_object_unref0 (grid);
#line 58 "../src/sudoku-view.vala"
	_g_object_unref0 (overlay);
#line 58 "../src/sudoku-view.vala"
	return self;
#line 1199 "sudoku-view.c"
}

SudokuView*
sudoku_view_new (SudokuGame* game,
                 GSettings* settings)
{
#line 58 "../src/sudoku-view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, game, settings);
#line 1208 "sudoku-view.c"
}

static void
sudoku_view_selection_changed_cb (SudokuView* self,
                                  gint old_row,
                                  gint old_col,
                                  gint new_row,
                                  gint new_col)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
#line 226 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 228 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, old_row, old_col, FALSE);
#line 229 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, new_row, new_col, TRUE);
#line 230 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 230 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 230 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 230 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_[(old_row * _tmp0__length2) + old_col];
#line 230 "../src/sudoku-view.vala"
	sudoku_cell_dismiss_popover (_tmp1_);
#line 1238 "sudoku-view.c"
}

static void
sudoku_view_cell_changed_cb (SudokuView* self,
                             gint row,
                             gint col,
                             gint old_val,
                             gint new_val)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuCell** _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	SudokuCell* _tmp7_;
#line 233 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 235 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 235 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 235 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 235 "../src/sudoku-view.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 235 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_;
#line 235 "../src/sudoku-view.vala"
	if (!_tmp3_) {
#line 1274 "sudoku-view.c"
		SudokuCell** _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		SudokuCell* _tmp5_;
#line 236 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->cells;
#line 236 "../src/sudoku-view.vala"
		_tmp4__length1 = self->priv->cells_length1;
#line 236 "../src/sudoku-view.vala"
		_tmp4__length2 = self->priv->cells_length2;
#line 236 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_[(row * _tmp4__length2) + col];
#line 236 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp5_);
#line 1289 "sudoku-view.c"
	}
#line 238 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->cells;
#line 238 "../src/sudoku-view.vala"
	_tmp6__length1 = self->priv->cells_length1;
#line 238 "../src/sudoku-view.vala"
	_tmp6__length2 = self->priv->cells_length2;
#line 238 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_[(row * _tmp6__length2) + col];
#line 238 "../src/sudoku-view.vala"
	sudoku_cell_update_value (_tmp7_);
#line 240 "../src/sudoku-view.vala"
	sudoku_view_update_warnings (self);
#line 241 "../src/sudoku-view.vala"
	sudoku_view_set_value_highlighter (self, old_val, FALSE);
#line 242 "../src/sudoku-view.vala"
	sudoku_view_set_value_highlighter (self, new_val, TRUE);
#line 1307 "sudoku-view.c"
}

static void
sudoku_view_earmark_changed_cb (SudokuView* self,
                                gint row,
                                gint col,
                                gint num,
                                gboolean enabled)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuCell** _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	SudokuCell* _tmp7_;
#line 245 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 247 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 247 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 247 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 247 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 247 "../src/sudoku-view.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 247 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_;
#line 247 "../src/sudoku-view.vala"
	if (!_tmp3_) {
#line 1343 "sudoku-view.c"
		SudokuCell** _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		SudokuCell* _tmp5_;
#line 248 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->cells;
#line 248 "../src/sudoku-view.vala"
		_tmp4__length1 = self->priv->cells_length1;
#line 248 "../src/sudoku-view.vala"
		_tmp4__length2 = self->priv->cells_length2;
#line 248 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_[(row * _tmp4__length2) + col];
#line 248 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp5_);
#line 1358 "sudoku-view.c"
	}
#line 250 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->cells;
#line 250 "../src/sudoku-view.vala"
	_tmp6__length1 = self->priv->cells_length1;
#line 250 "../src/sudoku-view.vala"
	_tmp6__length2 = self->priv->cells_length2;
#line 250 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_[(row * _tmp6__length2) + col];
#line 250 "../src/sudoku-view.vala"
	sudoku_cell_update_earmark (_tmp7_, num);
#line 251 "../src/sudoku-view.vala"
	if (enabled) {
#line 1372 "sudoku-view.c"
		SudokuCell** _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		SudokuCell* _tmp9_;
#line 252 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->cells;
#line 252 "../src/sudoku-view.vala"
		_tmp8__length1 = self->priv->cells_length1;
#line 252 "../src/sudoku-view.vala"
		_tmp8__length2 = self->priv->cells_length2;
#line 252 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_[(row * _tmp8__length2) + col];
#line 252 "../src/sudoku-view.vala"
		sudoku_cell_check_earmark_warnings (_tmp9_, num);
#line 1387 "sudoku-view.c"
	}
}

static void
sudoku_view_set_cell_highlighter (SudokuView* self,
                                  gint row,
                                  gint col,
                                  gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCell* cell = NULL;
	SudokuCell** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	SudokuCell* _tmp3_;
	SudokuCell* _tmp4_;
#line 255 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_highlighter (self);
#line 257 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 257 "../src/sudoku-view.vala"
	if (!_tmp1_) {
#line 258 "../src/sudoku-view.vala"
		return;
#line 1415 "sudoku-view.c"
	}
#line 260 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->cells;
#line 260 "../src/sudoku-view.vala"
	_tmp2__length1 = self->priv->cells_length1;
#line 260 "../src/sudoku-view.vala"
	_tmp2__length2 = self->priv->cells_length2;
#line 260 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 260 "../src/sudoku-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 260 "../src/sudoku-view.vala"
	cell = _tmp4_;
#line 1429 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 262 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1434 "sudoku-view.c"
		{
			gboolean _tmp5_ = FALSE;
#line 262 "../src/sudoku-view.vala"
			_tmp5_ = TRUE;
#line 262 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1441 "sudoku-view.c"
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				SudokuBoard* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 262 "../src/sudoku-view.vala"
				if (!_tmp5_) {
#line 1449 "sudoku-view.c"
					gint _tmp6_;
#line 262 "../src/sudoku-view.vala"
					_tmp6_ = col_tmp;
#line 262 "../src/sudoku-view.vala"
					col_tmp = _tmp6_ + 1;
#line 1455 "sudoku-view.c"
				}
#line 262 "../src/sudoku-view.vala"
				_tmp5_ = FALSE;
#line 262 "../src/sudoku-view.vala"
				_tmp7_ = self->priv->game;
#line 262 "../src/sudoku-view.vala"
				_tmp8_ = sudoku_game_get_board (_tmp7_);
#line 262 "../src/sudoku-view.vala"
				_tmp9_ = _tmp8_;
#line 262 "../src/sudoku-view.vala"
				_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 262 "../src/sudoku-view.vala"
				_tmp11_ = _tmp10_;
#line 262 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp11_)) {
#line 262 "../src/sudoku-view.vala"
					break;
#line 1473 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 264 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1479 "sudoku-view.c"
					{
						gboolean _tmp12_ = FALSE;
#line 264 "../src/sudoku-view.vala"
						_tmp12_ = TRUE;
#line 264 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1486 "sudoku-view.c"
							SudokuGame* _tmp14_;
							SudokuBoard* _tmp15_;
							SudokuBoard* _tmp16_;
							gint _tmp17_;
							gint _tmp18_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp19_;
							gint _tmp19__length1;
							gint _tmp19__length2;
							SudokuCell* _tmp20_;
							SudokuCell* _tmp21_;
							SudokuCell* _tmp22_;
							SudokuCell* _tmp23_;
							SudokuCell* _tmp24_;
							gint _tmp25_;
							gint _tmp26_;
							gboolean _tmp41_ = FALSE;
							SudokuCell* _tmp42_;
							gboolean _tmp43_;
							gboolean _tmp44_;
#line 264 "../src/sudoku-view.vala"
							if (!_tmp12_) {
#line 1509 "sudoku-view.c"
								gint _tmp13_;
#line 264 "../src/sudoku-view.vala"
								_tmp13_ = row_tmp;
#line 264 "../src/sudoku-view.vala"
								row_tmp = _tmp13_ + 1;
#line 1515 "sudoku-view.c"
							}
#line 264 "../src/sudoku-view.vala"
							_tmp12_ = FALSE;
#line 264 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->game;
#line 264 "../src/sudoku-view.vala"
							_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 264 "../src/sudoku-view.vala"
							_tmp16_ = _tmp15_;
#line 264 "../src/sudoku-view.vala"
							_tmp17_ = sudoku_board_get_rows (_tmp16_);
#line 264 "../src/sudoku-view.vala"
							_tmp18_ = _tmp17_;
#line 264 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp18_)) {
#line 264 "../src/sudoku-view.vala"
								break;
#line 1533 "sudoku-view.c"
							}
#line 266 "../src/sudoku-view.vala"
							_tmp19_ = self->priv->cells;
#line 266 "../src/sudoku-view.vala"
							_tmp19__length1 = self->priv->cells_length1;
#line 266 "../src/sudoku-view.vala"
							_tmp19__length2 = self->priv->cells_length2;
#line 266 "../src/sudoku-view.vala"
							_tmp20_ = _tmp19_[(row_tmp * _tmp19__length2) + col_tmp];
#line 266 "../src/sudoku-view.vala"
							_tmp21_ = _g_object_ref0 (_tmp20_);
#line 266 "../src/sudoku-view.vala"
							cell_tmp = _tmp21_;
#line 268 "../src/sudoku-view.vala"
							_tmp22_ = cell;
#line 268 "../src/sudoku-view.vala"
							_tmp23_ = cell_tmp;
#line 268 "../src/sudoku-view.vala"
							if (_tmp22_ == _tmp23_) {
#line 269 "../src/sudoku-view.vala"
								_g_object_unref0 (cell_tmp);
#line 269 "../src/sudoku-view.vala"
								continue;
#line 1557 "sudoku-view.c"
							}
#line 271 "../src/sudoku-view.vala"
							_tmp24_ = cell;
#line 271 "../src/sudoku-view.vala"
							_tmp25_ = sudoku_cell_get_value (_tmp24_);
#line 271 "../src/sudoku-view.vala"
							_tmp26_ = _tmp25_;
#line 271 "../src/sudoku-view.vala"
							if (_tmp26_ > 0) {
#line 1567 "sudoku-view.c"
								SudokuCell* _tmp27_;
								gint _tmp28_;
								gint _tmp29_;
								SudokuCell* _tmp30_;
								gint _tmp31_;
								gint _tmp32_;
#line 273 "../src/sudoku-view.vala"
								_tmp27_ = cell;
#line 273 "../src/sudoku-view.vala"
								_tmp28_ = sudoku_cell_get_value (_tmp27_);
#line 273 "../src/sudoku-view.vala"
								_tmp29_ = _tmp28_;
#line 273 "../src/sudoku-view.vala"
								_tmp30_ = cell_tmp;
#line 273 "../src/sudoku-view.vala"
								_tmp31_ = sudoku_cell_get_value (_tmp30_);
#line 273 "../src/sudoku-view.vala"
								_tmp32_ = _tmp31_;
#line 273 "../src/sudoku-view.vala"
								if (_tmp29_ == _tmp32_) {
#line 1588 "sudoku-view.c"
									SudokuCell* _tmp33_;
#line 274 "../src/sudoku-view.vala"
									_tmp33_ = cell_tmp;
#line 274 "../src/sudoku-view.vala"
									sudoku_cell_set_highlighted_value (_tmp33_, enabled);
#line 1594 "sudoku-view.c"
								} else {
									SudokuCell* _tmp34_;
									gint _tmp35_;
									gint _tmp36_;
#line 275 "../src/sudoku-view.vala"
									_tmp34_ = cell_tmp;
#line 275 "../src/sudoku-view.vala"
									_tmp35_ = sudoku_cell_get_value (_tmp34_);
#line 275 "../src/sudoku-view.vala"
									_tmp36_ = _tmp35_;
#line 275 "../src/sudoku-view.vala"
									if (_tmp36_ == 0) {
#line 1607 "sudoku-view.c"
										SudokuCell* _tmp37_;
										SudokuCell* _tmp38_;
										gint _tmp39_;
										gint _tmp40_;
#line 276 "../src/sudoku-view.vala"
										_tmp37_ = cell_tmp;
#line 276 "../src/sudoku-view.vala"
										_tmp38_ = cell;
#line 276 "../src/sudoku-view.vala"
										_tmp39_ = sudoku_cell_get_value (_tmp38_);
#line 276 "../src/sudoku-view.vala"
										_tmp40_ = _tmp39_;
#line 276 "../src/sudoku-view.vala"
										sudoku_cell_set_earmark_highlight (_tmp37_, _tmp40_, enabled);
#line 1622 "sudoku-view.c"
									}
								}
							}
#line 279 "../src/sudoku-view.vala"
							_tmp42_ = cell_tmp;
#line 279 "../src/sudoku-view.vala"
							_tmp43_ = sudoku_cell_get_is_fixed (_tmp42_);
#line 279 "../src/sudoku-view.vala"
							_tmp44_ = _tmp43_;
#line 279 "../src/sudoku-view.vala"
							if (!_tmp44_) {
#line 1634 "sudoku-view.c"
								gboolean _tmp45_ = FALSE;
								gboolean _tmp46_ = FALSE;
#line 280 "../src/sudoku-view.vala"
								if (row_tmp == row) {
#line 280 "../src/sudoku-view.vala"
									_tmp46_ = TRUE;
#line 1641 "sudoku-view.c"
								} else {
#line 280 "../src/sudoku-view.vala"
									_tmp46_ = col_tmp == col;
#line 1645 "sudoku-view.c"
								}
#line 280 "../src/sudoku-view.vala"
								if (_tmp46_) {
#line 280 "../src/sudoku-view.vala"
									_tmp45_ = TRUE;
#line 1651 "sudoku-view.c"
								} else {
									gboolean _tmp47_ = FALSE;
									SudokuGame* _tmp48_;
									SudokuBoard* _tmp49_;
									SudokuBoard* _tmp50_;
									gint _tmp51_;
									gint _tmp52_;
									SudokuGame* _tmp53_;
									SudokuBoard* _tmp54_;
									SudokuBoard* _tmp55_;
									gint _tmp56_;
									gint _tmp57_;
#line 281 "../src/sudoku-view.vala"
									_tmp48_ = self->priv->game;
#line 281 "../src/sudoku-view.vala"
									_tmp49_ = sudoku_game_get_board (_tmp48_);
#line 281 "../src/sudoku-view.vala"
									_tmp50_ = _tmp49_;
#line 281 "../src/sudoku-view.vala"
									_tmp51_ = sudoku_board_get_block_cols (_tmp50_);
#line 281 "../src/sudoku-view.vala"
									_tmp52_ = _tmp51_;
#line 281 "../src/sudoku-view.vala"
									_tmp53_ = self->priv->game;
#line 281 "../src/sudoku-view.vala"
									_tmp54_ = sudoku_game_get_board (_tmp53_);
#line 281 "../src/sudoku-view.vala"
									_tmp55_ = _tmp54_;
#line 281 "../src/sudoku-view.vala"
									_tmp56_ = sudoku_board_get_block_cols (_tmp55_);
#line 281 "../src/sudoku-view.vala"
									_tmp57_ = _tmp56_;
#line 281 "../src/sudoku-view.vala"
									if ((row_tmp / _tmp52_) == (row / _tmp57_)) {
#line 1686 "sudoku-view.c"
										SudokuGame* _tmp58_;
										SudokuBoard* _tmp59_;
										SudokuBoard* _tmp60_;
										gint _tmp61_;
										gint _tmp62_;
										SudokuGame* _tmp63_;
										SudokuBoard* _tmp64_;
										SudokuBoard* _tmp65_;
										gint _tmp66_;
										gint _tmp67_;
#line 282 "../src/sudoku-view.vala"
										_tmp58_ = self->priv->game;
#line 282 "../src/sudoku-view.vala"
										_tmp59_ = sudoku_game_get_board (_tmp58_);
#line 282 "../src/sudoku-view.vala"
										_tmp60_ = _tmp59_;
#line 282 "../src/sudoku-view.vala"
										_tmp61_ = sudoku_board_get_block_rows (_tmp60_);
#line 282 "../src/sudoku-view.vala"
										_tmp62_ = _tmp61_;
#line 282 "../src/sudoku-view.vala"
										_tmp63_ = self->priv->game;
#line 282 "../src/sudoku-view.vala"
										_tmp64_ = sudoku_game_get_board (_tmp63_);
#line 282 "../src/sudoku-view.vala"
										_tmp65_ = _tmp64_;
#line 282 "../src/sudoku-view.vala"
										_tmp66_ = sudoku_board_get_block_rows (_tmp65_);
#line 282 "../src/sudoku-view.vala"
										_tmp67_ = _tmp66_;
#line 282 "../src/sudoku-view.vala"
										_tmp47_ = (col_tmp / _tmp62_) == (col / _tmp67_);
#line 1719 "sudoku-view.c"
									} else {
#line 281 "../src/sudoku-view.vala"
										_tmp47_ = FALSE;
#line 1723 "sudoku-view.c"
									}
#line 281 "../src/sudoku-view.vala"
									_tmp45_ = _tmp47_;
#line 1727 "sudoku-view.c"
								}
#line 280 "../src/sudoku-view.vala"
								_tmp41_ = _tmp45_;
#line 1731 "sudoku-view.c"
							} else {
#line 279 "../src/sudoku-view.vala"
								_tmp41_ = FALSE;
#line 1735 "sudoku-view.c"
							}
#line 279 "../src/sudoku-view.vala"
							if (_tmp41_) {
#line 1739 "sudoku-view.c"
								SudokuCell* _tmp68_;
#line 284 "../src/sudoku-view.vala"
								_tmp68_ = cell_tmp;
#line 284 "../src/sudoku-view.vala"
								sudoku_cell_set_highlighted_background (_tmp68_, enabled);
#line 1745 "sudoku-view.c"
							}
#line 264 "../src/sudoku-view.vala"
							_g_object_unref0 (cell_tmp);
#line 1749 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 255 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 1758 "sudoku-view.c"
}

static void
sudoku_view_set_value_highlighter (SudokuView* self,
                                   gint val,
                                   gboolean enabled)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	SudokuCell* cell = NULL;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gint _tmp4_;
	gint _tmp5_;
	SudokuCell* _tmp6_;
	SudokuCell* _tmp7_;
#line 290 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 292 "../src/sudoku-view.vala"
	_tmp1_ = sudoku_view_get_highlighter (self);
#line 292 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 292 "../src/sudoku-view.vala"
	if (!_tmp2_) {
#line 292 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 1787 "sudoku-view.c"
	} else {
#line 292 "../src/sudoku-view.vala"
		_tmp0_ = val == 0;
#line 1791 "sudoku-view.c"
	}
#line 292 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 293 "../src/sudoku-view.vala"
		return;
#line 1797 "sudoku-view.c"
	}
#line 295 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->cells;
#line 295 "../src/sudoku-view.vala"
	_tmp3__length1 = self->priv->cells_length1;
#line 295 "../src/sudoku-view.vala"
	_tmp3__length2 = self->priv->cells_length2;
#line 295 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->_selected_row;
#line 295 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->_selected_col;
#line 295 "../src/sudoku-view.vala"
	_tmp6_ = _tmp3_[(_tmp4_ * _tmp3__length2) + _tmp5_];
#line 295 "../src/sudoku-view.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 295 "../src/sudoku-view.vala"
	cell = _tmp7_;
#line 1815 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 297 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1820 "sudoku-view.c"
		{
			gboolean _tmp8_ = FALSE;
#line 297 "../src/sudoku-view.vala"
			_tmp8_ = TRUE;
#line 297 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1827 "sudoku-view.c"
				SudokuGame* _tmp10_;
				SudokuBoard* _tmp11_;
				SudokuBoard* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 297 "../src/sudoku-view.vala"
				if (!_tmp8_) {
#line 1835 "sudoku-view.c"
					gint _tmp9_;
#line 297 "../src/sudoku-view.vala"
					_tmp9_ = col_tmp;
#line 297 "../src/sudoku-view.vala"
					col_tmp = _tmp9_ + 1;
#line 1841 "sudoku-view.c"
				}
#line 297 "../src/sudoku-view.vala"
				_tmp8_ = FALSE;
#line 297 "../src/sudoku-view.vala"
				_tmp10_ = self->priv->game;
#line 297 "../src/sudoku-view.vala"
				_tmp11_ = sudoku_game_get_board (_tmp10_);
#line 297 "../src/sudoku-view.vala"
				_tmp12_ = _tmp11_;
#line 297 "../src/sudoku-view.vala"
				_tmp13_ = sudoku_board_get_cols (_tmp12_);
#line 297 "../src/sudoku-view.vala"
				_tmp14_ = _tmp13_;
#line 297 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp14_)) {
#line 297 "../src/sudoku-view.vala"
					break;
#line 1859 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 299 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1865 "sudoku-view.c"
					{
						gboolean _tmp15_ = FALSE;
#line 299 "../src/sudoku-view.vala"
						_tmp15_ = TRUE;
#line 299 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1872 "sudoku-view.c"
							SudokuGame* _tmp17_;
							SudokuBoard* _tmp18_;
							SudokuBoard* _tmp19_;
							gint _tmp20_;
							gint _tmp21_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp22_;
							gint _tmp22__length1;
							gint _tmp22__length2;
							SudokuCell* _tmp23_;
							SudokuCell* _tmp24_;
							SudokuCell* _tmp25_;
							SudokuCell* _tmp26_;
							SudokuCell* _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
#line 299 "../src/sudoku-view.vala"
							if (!_tmp15_) {
#line 1891 "sudoku-view.c"
								gint _tmp16_;
#line 299 "../src/sudoku-view.vala"
								_tmp16_ = row_tmp;
#line 299 "../src/sudoku-view.vala"
								row_tmp = _tmp16_ + 1;
#line 1897 "sudoku-view.c"
							}
#line 299 "../src/sudoku-view.vala"
							_tmp15_ = FALSE;
#line 299 "../src/sudoku-view.vala"
							_tmp17_ = self->priv->game;
#line 299 "../src/sudoku-view.vala"
							_tmp18_ = sudoku_game_get_board (_tmp17_);
#line 299 "../src/sudoku-view.vala"
							_tmp19_ = _tmp18_;
#line 299 "../src/sudoku-view.vala"
							_tmp20_ = sudoku_board_get_rows (_tmp19_);
#line 299 "../src/sudoku-view.vala"
							_tmp21_ = _tmp20_;
#line 299 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp21_)) {
#line 299 "../src/sudoku-view.vala"
								break;
#line 1915 "sudoku-view.c"
							}
#line 301 "../src/sudoku-view.vala"
							_tmp22_ = self->priv->cells;
#line 301 "../src/sudoku-view.vala"
							_tmp22__length1 = self->priv->cells_length1;
#line 301 "../src/sudoku-view.vala"
							_tmp22__length2 = self->priv->cells_length2;
#line 301 "../src/sudoku-view.vala"
							_tmp23_ = _tmp22_[(row_tmp * _tmp22__length2) + col_tmp];
#line 301 "../src/sudoku-view.vala"
							_tmp24_ = _g_object_ref0 (_tmp23_);
#line 301 "../src/sudoku-view.vala"
							cell_tmp = _tmp24_;
#line 303 "../src/sudoku-view.vala"
							_tmp25_ = cell;
#line 303 "../src/sudoku-view.vala"
							_tmp26_ = cell_tmp;
#line 303 "../src/sudoku-view.vala"
							if (_tmp25_ == _tmp26_) {
#line 304 "../src/sudoku-view.vala"
								_g_object_unref0 (cell_tmp);
#line 304 "../src/sudoku-view.vala"
								continue;
#line 1939 "sudoku-view.c"
							}
#line 306 "../src/sudoku-view.vala"
							_tmp27_ = cell_tmp;
#line 306 "../src/sudoku-view.vala"
							_tmp28_ = sudoku_cell_get_value (_tmp27_);
#line 306 "../src/sudoku-view.vala"
							_tmp29_ = _tmp28_;
#line 306 "../src/sudoku-view.vala"
							if (val == _tmp29_) {
#line 1949 "sudoku-view.c"
								SudokuCell* _tmp30_;
#line 307 "../src/sudoku-view.vala"
								_tmp30_ = cell_tmp;
#line 307 "../src/sudoku-view.vala"
								sudoku_cell_set_highlighted_value (_tmp30_, enabled);
#line 1955 "sudoku-view.c"
							} else {
								SudokuCell* _tmp31_;
								gint _tmp32_;
								gint _tmp33_;
#line 308 "../src/sudoku-view.vala"
								_tmp31_ = cell_tmp;
#line 308 "../src/sudoku-view.vala"
								_tmp32_ = sudoku_cell_get_value (_tmp31_);
#line 308 "../src/sudoku-view.vala"
								_tmp33_ = _tmp32_;
#line 308 "../src/sudoku-view.vala"
								if (_tmp33_ == 0) {
#line 1968 "sudoku-view.c"
									SudokuCell* _tmp34_;
#line 309 "../src/sudoku-view.vala"
									_tmp34_ = cell_tmp;
#line 309 "../src/sudoku-view.vala"
									sudoku_cell_set_earmark_highlight (_tmp34_, val, enabled);
#line 1974 "sudoku-view.c"
								}
							}
#line 299 "../src/sudoku-view.vala"
							_g_object_unref0 (cell_tmp);
#line 1979 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 290 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 1988 "sudoku-view.c"
}

static void
sudoku_view_update_warnings (SudokuView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 314 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 316 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 316 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 316 "../src/sudoku-view.vala"
	if (!_tmp1_) {
#line 317 "../src/sudoku-view.vala"
		return;
#line 2006 "sudoku-view.c"
	}
	{
		gint col = 0;
#line 319 "../src/sudoku-view.vala"
		col = 0;
#line 2012 "sudoku-view.c"
		{
			gboolean _tmp2_ = FALSE;
#line 319 "../src/sudoku-view.vala"
			_tmp2_ = TRUE;
#line 319 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2019 "sudoku-view.c"
				SudokuGame* _tmp4_;
				SudokuBoard* _tmp5_;
				SudokuBoard* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 319 "../src/sudoku-view.vala"
				if (!_tmp2_) {
#line 2027 "sudoku-view.c"
					gint _tmp3_;
#line 319 "../src/sudoku-view.vala"
					_tmp3_ = col;
#line 319 "../src/sudoku-view.vala"
					col = _tmp3_ + 1;
#line 2033 "sudoku-view.c"
				}
#line 319 "../src/sudoku-view.vala"
				_tmp2_ = FALSE;
#line 319 "../src/sudoku-view.vala"
				_tmp4_ = self->priv->game;
#line 319 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_game_get_board (_tmp4_);
#line 319 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 319 "../src/sudoku-view.vala"
				_tmp7_ = sudoku_board_get_cols (_tmp6_);
#line 319 "../src/sudoku-view.vala"
				_tmp8_ = _tmp7_;
#line 319 "../src/sudoku-view.vala"
				if (!(col < _tmp8_)) {
#line 319 "../src/sudoku-view.vala"
					break;
#line 2051 "sudoku-view.c"
				}
				{
					gint row = 0;
#line 320 "../src/sudoku-view.vala"
					row = 0;
#line 2057 "sudoku-view.c"
					{
						gboolean _tmp9_ = FALSE;
#line 320 "../src/sudoku-view.vala"
						_tmp9_ = TRUE;
#line 320 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2064 "sudoku-view.c"
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
							gboolean _tmp18_;
							gboolean _tmp19_;
							SudokuCell** _tmp20_;
							gint _tmp20__length1;
							gint _tmp20__length2;
							SudokuCell* _tmp21_;
#line 320 "../src/sudoku-view.vala"
							if (!_tmp9_) {
#line 2082 "sudoku-view.c"
								gint _tmp10_;
#line 320 "../src/sudoku-view.vala"
								_tmp10_ = row;
#line 320 "../src/sudoku-view.vala"
								row = _tmp10_ + 1;
#line 2088 "sudoku-view.c"
							}
#line 320 "../src/sudoku-view.vala"
							_tmp9_ = FALSE;
#line 320 "../src/sudoku-view.vala"
							_tmp11_ = self->priv->game;
#line 320 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 320 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 320 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_rows (_tmp13_);
#line 320 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 320 "../src/sudoku-view.vala"
							if (!(row < _tmp15_)) {
#line 320 "../src/sudoku-view.vala"
								break;
#line 2106 "sudoku-view.c"
							}
#line 322 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 322 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 322 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 322 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(row * _tmp16__length2) + col];
#line 322 "../src/sudoku-view.vala"
							_tmp18_ = sudoku_view_get_show_extra_warnings (self);
#line 322 "../src/sudoku-view.vala"
							_tmp19_ = _tmp18_;
#line 322 "../src/sudoku-view.vala"
							sudoku_cell_check_value_warnings (_tmp17_, _tmp19_);
#line 323 "../src/sudoku-view.vala"
							_tmp20_ = self->priv->cells;
#line 323 "../src/sudoku-view.vala"
							_tmp20__length1 = self->priv->cells_length1;
#line 323 "../src/sudoku-view.vala"
							_tmp20__length2 = self->priv->cells_length2;
#line 323 "../src/sudoku-view.vala"
							_tmp21_ = _tmp20_[(row * _tmp20__length2) + col];
#line 323 "../src/sudoku-view.vala"
							sudoku_cell_check_earmarks_warnings (_tmp21_);
#line 2132 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_clear (SudokuView* self)
{
#line 327 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2146 "sudoku-view.c"
	{
		gint i = 0;
#line 329 "../src/sudoku-view.vala"
		i = 0;
#line 2151 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 329 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 329 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2158 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 329 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2166 "sudoku-view.c"
					gint _tmp1_;
#line 329 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 329 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2172 "sudoku-view.c"
				}
#line 329 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 329 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 329 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 329 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 329 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_rows (_tmp4_);
#line 329 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 329 "../src/sudoku-view.vala"
				if (!(i < _tmp6_)) {
#line 329 "../src/sudoku-view.vala"
					break;
#line 2190 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 330 "../src/sudoku-view.vala"
					j = 0;
#line 2196 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 330 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 330 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2203 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuGame* _tmp14_;
							SudokuBoard* _tmp15_;
							SudokuBoard* _tmp16_;
#line 330 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2214 "sudoku-view.c"
								gint _tmp8_;
#line 330 "../src/sudoku-view.vala"
								_tmp8_ = j;
#line 330 "../src/sudoku-view.vala"
								j = _tmp8_ + 1;
#line 2220 "sudoku-view.c"
							}
#line 330 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 330 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 330 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 330 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 330 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_cols (_tmp11_);
#line 330 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 330 "../src/sudoku-view.vala"
							if (!(j < _tmp13_)) {
#line 330 "../src/sudoku-view.vala"
								break;
#line 2238 "sudoku-view.c"
							}
#line 331 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->game;
#line 331 "../src/sudoku-view.vala"
							_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 331 "../src/sudoku-view.vala"
							_tmp16_ = _tmp15_;
#line 331 "../src/sudoku-view.vala"
							sudoku_board_disable_all_earmarks (_tmp16_, i, j);
#line 2248 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_clear_all_warnings (SudokuView* self)
{
#line 334 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2262 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 336 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2267 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 336 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 336 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2274 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 336 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2282 "sudoku-view.c"
					gint _tmp1_;
#line 336 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 336 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 2288 "sudoku-view.c"
				}
#line 336 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 336 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 336 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 336 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 336 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
#line 336 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 336 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp6_)) {
#line 336 "../src/sudoku-view.vala"
					break;
#line 2306 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 337 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2312 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 337 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 337 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2319 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 337 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2331 "sudoku-view.c"
								gint _tmp8_;
#line 337 "../src/sudoku-view.vala"
								_tmp8_ = row_tmp;
#line 337 "../src/sudoku-view.vala"
								row_tmp = _tmp8_ + 1;
#line 2337 "sudoku-view.c"
							}
#line 337 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 337 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 337 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 337 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 337 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
#line 337 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 337 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp13_)) {
#line 337 "../src/sudoku-view.vala"
								break;
#line 2355 "sudoku-view.c"
							}
#line 338 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 338 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 338 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 338 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 338 "../src/sudoku-view.vala"
							sudoku_cell_clear_warnings (_tmp15_);
#line 2367 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_mask_view (SudokuView* self)
{
#line 341 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2381 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 343 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2386 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 343 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 343 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2393 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 343 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2401 "sudoku-view.c"
					gint _tmp1_;
#line 343 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 343 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 2407 "sudoku-view.c"
				}
#line 343 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 343 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 343 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 343 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 343 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
#line 343 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 343 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp6_)) {
#line 343 "../src/sudoku-view.vala"
					break;
#line 2425 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 344 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2431 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 344 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 344 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2438 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 344 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2450 "sudoku-view.c"
								gint _tmp8_;
#line 344 "../src/sudoku-view.vala"
								_tmp8_ = row_tmp;
#line 344 "../src/sudoku-view.vala"
								row_tmp = _tmp8_ + 1;
#line 2456 "sudoku-view.c"
							}
#line 344 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 344 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 344 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 344 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 344 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
#line 344 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 344 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp13_)) {
#line 344 "../src/sudoku-view.vala"
								break;
#line 2474 "sudoku-view.c"
							}
#line 345 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 345 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 345 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 345 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 345 "../src/sudoku-view.vala"
							sudoku_cell_set_paused (_tmp15_, TRUE);
#line 2486 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_unmask_view (SudokuView* self)
{
#line 348 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2500 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 350 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 2505 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 350 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 350 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2512 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 350 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2520 "sudoku-view.c"
					gint _tmp1_;
#line 350 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 350 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 2526 "sudoku-view.c"
				}
#line 350 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 350 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 350 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 350 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 350 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
#line 350 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 350 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp6_)) {
#line 350 "../src/sudoku-view.vala"
					break;
#line 2544 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 351 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 2550 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 351 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 351 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2557 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 351 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2569 "sudoku-view.c"
								gint _tmp8_;
#line 351 "../src/sudoku-view.vala"
								_tmp8_ = row_tmp;
#line 351 "../src/sudoku-view.vala"
								row_tmp = _tmp8_ + 1;
#line 2575 "sudoku-view.c"
							}
#line 351 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 351 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 351 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 351 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 351 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
#line 351 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 351 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp13_)) {
#line 351 "../src/sudoku-view.vala"
								break;
#line 2593 "sudoku-view.c"
							}
#line 352 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 352 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 352 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 352 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 352 "../src/sudoku-view.vala"
							sudoku_cell_set_paused (_tmp15_, FALSE);
#line 2605 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_dismiss_popovers (SudokuView* self)
{
#line 427 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2619 "sudoku-view.c"
	{
		gint i = 0;
#line 429 "../src/sudoku-view.vala"
		i = 0;
#line 2624 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 429 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 429 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2631 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 429 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2639 "sudoku-view.c"
					gint _tmp1_;
#line 429 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 429 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2645 "sudoku-view.c"
				}
#line 429 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 429 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 429 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 429 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 429 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_rows (_tmp4_);
#line 429 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 429 "../src/sudoku-view.vala"
				if (!(i < _tmp6_)) {
#line 429 "../src/sudoku-view.vala"
					break;
#line 2663 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 430 "../src/sudoku-view.vala"
					j = 0;
#line 2669 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 430 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 430 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2676 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 430 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2688 "sudoku-view.c"
								gint _tmp8_;
#line 430 "../src/sudoku-view.vala"
								_tmp8_ = j;
#line 430 "../src/sudoku-view.vala"
								j = _tmp8_ + 1;
#line 2694 "sudoku-view.c"
							}
#line 430 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 430 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 430 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 430 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 430 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_cols (_tmp11_);
#line 430 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 430 "../src/sudoku-view.vala"
							if (!(j < _tmp13_)) {
#line 430 "../src/sudoku-view.vala"
								break;
#line 2712 "sudoku-view.c"
							}
#line 431 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 431 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 431 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 431 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_[(i * _tmp14__length2) + j];
#line 431 "../src/sudoku-view.vala"
							sudoku_cell_dismiss_popover (_tmp15_);
#line 2724 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_real_dispose (GObject* base)
{
	SudokuView * self;
	SudokuFrame* _tmp0_;
#line 434 "../src/sudoku-view.vala"
	self = (SudokuView*) base;
#line 436 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->frame;
#line 436 "../src/sudoku-view.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 437 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_bin_get_type (), AdwBin));
#line 2746 "sudoku-view.c"
}

gint
sudoku_view_get_selected_row (SudokuView* self)
{
	gint result;
#line 33 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 33 "../src/sudoku-view.vala"
	result = self->priv->_selected_row;
#line 33 "../src/sudoku-view.vala"
	return result;
#line 2759 "sudoku-view.c"
}

static void
sudoku_view_set_selected_row (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 33 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/sudoku-view.vala"
	old_value = sudoku_view_get_selected_row (self);
#line 33 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 33 "../src/sudoku-view.vala"
		self->priv->_selected_row = value;
#line 33 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY]);
#line 2777 "sudoku-view.c"
	}
}

gint
sudoku_view_get_selected_col (SudokuView* self)
{
	gint result;
#line 34 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "../src/sudoku-view.vala"
	result = self->priv->_selected_col;
#line 34 "../src/sudoku-view.vala"
	return result;
#line 2791 "sudoku-view.c"
}

static void
sudoku_view_set_selected_col (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 34 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/sudoku-view.vala"
	old_value = sudoku_view_get_selected_col (self);
#line 34 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 34 "../src/sudoku-view.vala"
		self->priv->_selected_col = value;
#line 34 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY]);
#line 2809 "sudoku-view.c"
	}
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
#line 358 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 358 "../src/sudoku-view.vala"
	result = self->priv->_show_warnings;
#line 358 "../src/sudoku-view.vala"
	return result;
#line 2823 "sudoku-view.c"
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 359 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 362 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 362 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 362 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 363 "../src/sudoku-view.vala"
		sudoku_view_update_warnings (self);
#line 2846 "sudoku-view.c"
	} else {
#line 365 "../src/sudoku-view.vala"
		sudoku_view_clear_all_warnings (self);
#line 2850 "sudoku-view.c"
	}
#line 367 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_row;
#line 367 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->_selected_col;
#line 367 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, TRUE);
#line 359 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 2860 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_extra_warnings (SudokuView* self)
{
	gboolean result;
#line 374 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 374 "../src/sudoku-view.vala"
	result = self->priv->_show_extra_warnings;
#line 374 "../src/sudoku-view.vala"
	return result;
#line 2873 "sudoku-view.c"
}

void
sudoku_view_set_show_extra_warnings (SudokuView* self,
                                     gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 375 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 376 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = value;
#line 377 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 377 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 377 "../src/sudoku-view.vala"
	sudoku_view_set_show_warnings (self, _tmp1_);
#line 375 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 2894 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
#line 384 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 384 "../src/sudoku-view.vala"
	result = self->priv->_show_possibilities;
#line 384 "../src/sudoku-view.vala"
	return result;
#line 2907 "sudoku-view.c"
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
#line 385 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 386 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 2918 "sudoku-view.c"
	{
		gint row = 0;
#line 387 "../src/sudoku-view.vala"
		row = 0;
#line 2923 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 387 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 387 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2930 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 387 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2938 "sudoku-view.c"
					gint _tmp1_;
#line 387 "../src/sudoku-view.vala"
					_tmp1_ = row;
#line 387 "../src/sudoku-view.vala"
					row = _tmp1_ + 1;
#line 2944 "sudoku-view.c"
				}
#line 387 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 387 "../src/sudoku-view.vala"
				_tmp2_ = self->priv->game;
#line 387 "../src/sudoku-view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 387 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_;
#line 387 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_rows (_tmp4_);
#line 387 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 387 "../src/sudoku-view.vala"
				if (!(row < _tmp6_)) {
#line 387 "../src/sudoku-view.vala"
					break;
#line 2962 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 388 "../src/sudoku-view.vala"
					col = 0;
#line 2968 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 388 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 388 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2975 "sudoku-view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							gboolean _tmp14_;
							gboolean _tmp15_;
#line 388 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 2985 "sudoku-view.c"
								gint _tmp8_;
#line 388 "../src/sudoku-view.vala"
								_tmp8_ = col;
#line 388 "../src/sudoku-view.vala"
								col = _tmp8_ + 1;
#line 2991 "sudoku-view.c"
							}
#line 388 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 388 "../src/sudoku-view.vala"
							_tmp9_ = self->priv->game;
#line 388 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 388 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 388 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_cols (_tmp11_);
#line 388 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 388 "../src/sudoku-view.vala"
							if (!(col < _tmp13_)) {
#line 388 "../src/sudoku-view.vala"
								break;
#line 3009 "sudoku-view.c"
							}
#line 390 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_view_get_show_possibilities (self);
#line 390 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 390 "../src/sudoku-view.vala"
							if (_tmp15_) {
#line 3017 "sudoku-view.c"
								SudokuCell** _tmp16_;
								gint _tmp16__length1;
								gint _tmp16__length2;
								SudokuCell* _tmp17_;
								gboolean _tmp18_;
								gboolean _tmp19_;
#line 391 "../src/sudoku-view.vala"
								_tmp16_ = self->priv->cells;
#line 391 "../src/sudoku-view.vala"
								_tmp16__length1 = self->priv->cells_length1;
#line 391 "../src/sudoku-view.vala"
								_tmp16__length2 = self->priv->cells_length2;
#line 391 "../src/sudoku-view.vala"
								_tmp17_ = _tmp16_[(row * _tmp16__length2) + col];
#line 391 "../src/sudoku-view.vala"
								_tmp18_ = sudoku_view_get_show_possibilities (self);
#line 391 "../src/sudoku-view.vala"
								_tmp19_ = _tmp18_;
#line 391 "../src/sudoku-view.vala"
								sudoku_cell_initialize_earmarks (_tmp17_, _tmp19_, TRUE);
#line 3038 "sudoku-view.c"
							} else {
								SudokuGame* _tmp20_;
#line 393 "../src/sudoku-view.vala"
								_tmp20_ = self->priv->game;
#line 393 "../src/sudoku-view.vala"
								sudoku_game_disable_all_earmarks (_tmp20_, row, col);
#line 3045 "sudoku-view.c"
							}
						}
					}
				}
			}
		}
	}
#line 385 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 3055 "sudoku-view.c"
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
#line 402 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 402 "../src/sudoku-view.vala"
	result = self->priv->_highlighter;
#line 402 "../src/sudoku-view.vala"
	return result;
#line 3068 "sudoku-view.c"
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 403 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 404 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_selected_row;
#line 404 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_col;
#line 404 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp0_, _tmp1_, FALSE);
#line 405 "../src/sudoku-view.vala"
	self->priv->_highlighter = value;
#line 406 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_row;
#line 406 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->_selected_col;
#line 406 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, TRUE);
#line 403 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 3097 "sudoku-view.c"
}

gboolean
sudoku_view_get_has_selection (SudokuView* self)
{
	gboolean result;
#line 413 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 413 "../src/sudoku-view.vala"
	result = self->priv->_has_selection;
#line 413 "../src/sudoku-view.vala"
	return result;
#line 3110 "sudoku-view.c"
}

void
sudoku_view_set_has_selection (SudokuView* self,
                               gboolean value)
{
	SudokuCell* cell = NULL;
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint _tmp2_;
	SudokuCell* _tmp3_;
	SudokuCell* _tmp4_;
	SudokuCell* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gint _tmp12_;
	gint _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
#line 414 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 415 "../src/sudoku-view.vala"
	self->priv->_has_selection = value;
#line 416 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 416 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 416 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 416 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 416 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->_selected_col;
#line 416 "../src/sudoku-view.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 416 "../src/sudoku-view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 416 "../src/sudoku-view.vala"
	cell = _tmp4_;
#line 417 "../src/sudoku-view.vala"
	_tmp5_ = cell;
#line 417 "../src/sudoku-view.vala"
	_tmp6_ = sudoku_view_get_has_selection (self);
#line 417 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_;
#line 417 "../src/sudoku-view.vala"
	sudoku_cell_set_selected (_tmp5_, _tmp7_);
#line 418 "../src/sudoku-view.vala"
	_tmp8_ = sudoku_view_get_has_selection (self);
#line 418 "../src/sudoku-view.vala"
	_tmp9_ = _tmp8_;
#line 418 "../src/sudoku-view.vala"
	if (_tmp9_) {
#line 3168 "sudoku-view.c"
		SudokuCell* _tmp10_;
#line 419 "../src/sudoku-view.vala"
		_tmp10_ = cell;
#line 419 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 3174 "sudoku-view.c"
	} else {
		SudokuCell* _tmp11_;
#line 421 "../src/sudoku-view.vala"
		_tmp11_ = cell;
#line 421 "../src/sudoku-view.vala"
		sudoku_cell_dismiss_popover (_tmp11_);
#line 3181 "sudoku-view.c"
	}
#line 423 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->_selected_row;
#line 423 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->_selected_col;
#line 423 "../src/sudoku-view.vala"
	_tmp14_ = sudoku_view_get_has_selection (self);
#line 423 "../src/sudoku-view.vala"
	_tmp15_ = _tmp14_;
#line 423 "../src/sudoku-view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp12_, _tmp13_, _tmp15_);
#line 414 "../src/sudoku-view.vala"
	_g_object_unref0 (cell);
#line 414 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY]);
#line 3197 "sudoku-view.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 26 "../src/sudoku-view.vala"
	g_return_if_fail (n_param_values == 5);
#line 26 "../src/sudoku-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 26 "../src/sudoku-view.vala"
		data1 = closure->data;
#line 26 "../src/sudoku-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 3222 "sudoku-view.c"
	} else {
#line 26 "../src/sudoku-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 26 "../src/sudoku-view.vala"
		data2 = closure->data;
#line 3228 "sudoku-view.c"
	}
#line 26 "../src/sudoku-view.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 26 "../src/sudoku-view.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 3234 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda9_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 159 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 160 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 160 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 162 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 162 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 162 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 162 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3262 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 162 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 162 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 162 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3272 "sudoku-view.c"
	}
#line 162 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 163 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 163 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 163 "../src/sudoku-view.vala"
		return result;
#line 3282 "sudoku-view.c"
	}
#line 165 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 165 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_row;
#line 165 "../src/sudoku-view.vala"
	if (_tmp7_ == 0) {
#line 3290 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 166 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 166 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 166 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 166 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 166 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 166 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_col;
#line 166 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(8 * _tmp9__length2) + _tmp11_];
#line 166 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3314 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 168 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 168 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 168 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 168 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 168 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 168 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 168 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 168 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 168 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[((_tmp16_ - 1) * _tmp14__length2) + _tmp18_];
#line 168 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3345 "sudoku-view.c"
	}
#line 170 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 170 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 170 "../src/sudoku-view.vala"
	return result;
#line 3353 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda9__gtk_shortcut_func (GtkWidget* widget,
                                            GVariant* args,
                                            gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda9_ (widget);
#line 159 "../src/sudoku-view.vala"
	return result;
#line 3365 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda10_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 172 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 173 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 173 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 175 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 175 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 175 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 175 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3393 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 175 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 175 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 175 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3403 "sudoku-view.c"
	}
#line 175 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 176 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 176 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 176 "../src/sudoku-view.vala"
		return result;
#line 3413 "sudoku-view.c"
	}
#line 178 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 178 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_row;
#line 178 "../src/sudoku-view.vala"
	if (_tmp7_ == 8) {
#line 3421 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 179 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 179 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 179 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 179 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 179 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 179 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_col;
#line 179 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(0 * _tmp9__length2) + _tmp11_];
#line 179 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3445 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 181 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 181 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 181 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 181 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 181 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 181 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 181 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 181 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 181 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[((_tmp16_ + 1) * _tmp14__length2) + _tmp18_];
#line 181 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3476 "sudoku-view.c"
	}
#line 183 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 183 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 183 "../src/sudoku-view.vala"
	return result;
#line 3484 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda10__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda10_ (widget);
#line 172 "../src/sudoku-view.vala"
	return result;
#line 3496 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda11_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 185 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 186 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 186 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 188 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 188 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 188 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 188 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3524 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 188 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 188 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 188 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3534 "sudoku-view.c"
	}
#line 188 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 189 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 189 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 189 "../src/sudoku-view.vala"
		return result;
#line 3544 "sudoku-view.c"
	}
#line 191 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 191 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_col;
#line 191 "../src/sudoku-view.vala"
	if (_tmp7_ == 0) {
#line 3552 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 192 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 192 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 192 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 192 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 192 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 192 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_row;
#line 192 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(_tmp11_ * _tmp9__length2) + 8];
#line 192 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3576 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 194 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 194 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 194 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 194 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 194 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 194 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 194 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 194 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 194 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + (_tmp18_ - 1)];
#line 194 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3607 "sudoku-view.c"
	}
#line 196 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 196 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 196 "../src/sudoku-view.vala"
	return result;
#line 3615 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda11__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda11_ (widget);
#line 185 "../src/sudoku-view.vala"
	return result;
#line 3627 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda12_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	gboolean result;
#line 198 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 199 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 199 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 201 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 201 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 201 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 201 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3655 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 201 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 201 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 201 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3665 "sudoku-view.c"
	}
#line 201 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 202 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 202 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 202 "../src/sudoku-view.vala"
		return result;
#line 3675 "sudoku-view.c"
	}
#line 204 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 204 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_col;
#line 204 "../src/sudoku-view.vala"
	if (_tmp7_ == 8) {
#line 3683 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 205 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 205 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 205 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 205 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 205 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 205 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_row;
#line 205 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(_tmp11_ * _tmp9__length2) + 0];
#line 205 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3707 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 207 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 207 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 207 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 207 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 207 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 207 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 207 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 207 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 207 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + (_tmp18_ + 1)];
#line 207 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3738 "sudoku-view.c"
	}
#line 209 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 209 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 209 "../src/sudoku-view.vala"
	return result;
#line 3746 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda12__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda12_ (widget);
#line 198 "../src/sudoku-view.vala"
	return result;
#line 3758 "sudoku-view.c"
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
	GtkShortcutFunc up_func = NULL;
	gpointer up_func_target;
	GDestroyNotify up_func_target_destroy_notify;
	GtkShortcutFunc down_func = NULL;
	gpointer down_func_target;
	GDestroyNotify down_func_target_destroy_notify;
	GtkShortcutFunc left_func = NULL;
	gpointer left_func_target;
	GDestroyNotify left_func_target_destroy_notify;
	GtkShortcutFunc right_func = NULL;
	gpointer right_func_target;
	GDestroyNotify right_func_target_destroy_notify;
	GtkShortcutFunc _tmp0_;
	gpointer _tmp0__target;
	GtkShortcutFunc _tmp1_;
	gpointer _tmp1__target;
	GtkShortcutFunc _tmp2_;
	gpointer _tmp2__target;
	GtkShortcutFunc _tmp3_;
	gpointer _tmp3__target;
	GtkShortcutFunc _tmp4_;
	gpointer _tmp4__target;
	GtkShortcutFunc _tmp5_;
	gpointer _tmp5__target;
	GtkShortcutFunc _tmp6_;
	gpointer _tmp6__target;
	GtkShortcutFunc _tmp7_;
	gpointer _tmp7__target;
	GtkShortcutFunc _tmp8_;
	gpointer _tmp8__target;
	GtkShortcutFunc _tmp9_;
	gpointer _tmp9__target;
	GtkShortcutFunc _tmp10_;
	gpointer _tmp10__target;
	GtkShortcutFunc _tmp11_;
	gpointer _tmp11__target;
#line 26 "../src/sudoku-view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 26 "../src/sudoku-view.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_view_real_dispose;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_ROW_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY] = g_param_spec_int ("selected-row", "selected-row", "selected-row", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_COL_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY] = g_param_spec_int ("selected-col", "selected-col", "selected-col", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HAS_SELECTION_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY] = g_param_spec_boolean ("has-selection", "has-selection", "has-selection", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", TYPE_SUDOKU_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 159 "../src/sudoku-view.vala"
	up_func = __sudoku_view___lambda9__gtk_shortcut_func;
#line 159 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 159 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 172 "../src/sudoku-view.vala"
	down_func = __sudoku_view___lambda10__gtk_shortcut_func;
#line 172 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 172 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 185 "../src/sudoku-view.vala"
	left_func = __sudoku_view___lambda11__gtk_shortcut_func;
#line 185 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 185 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 198 "../src/sudoku-view.vala"
	right_func = __sudoku_view___lambda12__gtk_shortcut_func;
#line 198 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 198 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 212 "../src/sudoku-view.vala"
	_tmp0_ = up_func;
#line 212 "../src/sudoku-view.vala"
	_tmp0__target = up_func_target;
#line 212 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Up, 0, _tmp0_, _tmp0__target, NULL, NULL);
#line 213 "../src/sudoku-view.vala"
	_tmp1_ = up_func;
#line 213 "../src/sudoku-view.vala"
	_tmp1__target = up_func_target;
#line 213 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Up, 0, _tmp1_, _tmp1__target, NULL, NULL);
#line 214 "../src/sudoku-view.vala"
	_tmp2_ = up_func;
#line 214 "../src/sudoku-view.vala"
	_tmp2__target = up_func_target;
#line 214 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_w, 0, _tmp2_, _tmp2__target, NULL, NULL);
#line 215 "../src/sudoku-view.vala"
	_tmp3_ = down_func;
#line 215 "../src/sudoku-view.vala"
	_tmp3__target = down_func_target;
#line 215 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Down, 0, _tmp3_, _tmp3__target, NULL, NULL);
#line 216 "../src/sudoku-view.vala"
	_tmp4_ = down_func;
#line 216 "../src/sudoku-view.vala"
	_tmp4__target = down_func_target;
#line 216 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Down, 0, _tmp4_, _tmp4__target, NULL, NULL);
#line 217 "../src/sudoku-view.vala"
	_tmp5_ = down_func;
#line 217 "../src/sudoku-view.vala"
	_tmp5__target = down_func_target;
#line 217 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_s, 0, _tmp5_, _tmp5__target, NULL, NULL);
#line 218 "../src/sudoku-view.vala"
	_tmp6_ = left_func;
#line 218 "../src/sudoku-view.vala"
	_tmp6__target = left_func_target;
#line 218 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Left, 0, _tmp6_, _tmp6__target, NULL, NULL);
#line 219 "../src/sudoku-view.vala"
	_tmp7_ = left_func;
#line 219 "../src/sudoku-view.vala"
	_tmp7__target = left_func_target;
#line 219 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Left, 0, _tmp7_, _tmp7__target, NULL, NULL);
#line 220 "../src/sudoku-view.vala"
	_tmp8_ = left_func;
#line 220 "../src/sudoku-view.vala"
	_tmp8__target = left_func_target;
#line 220 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_a, 0, _tmp8_, _tmp8__target, NULL, NULL);
#line 221 "../src/sudoku-view.vala"
	_tmp9_ = right_func;
#line 221 "../src/sudoku-view.vala"
	_tmp9__target = right_func_target;
#line 221 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Right, 0, _tmp9_, _tmp9__target, NULL, NULL);
#line 222 "../src/sudoku-view.vala"
	_tmp10_ = right_func;
#line 222 "../src/sudoku-view.vala"
	_tmp10__target = right_func_target;
#line 222 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Right, 0, _tmp10_, _tmp10__target, NULL, NULL);
#line 223 "../src/sudoku-view.vala"
	_tmp11_ = right_func;
#line 223 "../src/sudoku-view.vala"
	_tmp11__target = right_func_target;
#line 223 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_d, 0, _tmp11_, _tmp11__target, NULL, NULL);
#line 158 "../src/sudoku-view.vala"
	(right_func_target_destroy_notify == NULL) ? NULL : (right_func_target_destroy_notify (right_func_target), NULL);
#line 158 "../src/sudoku-view.vala"
	right_func = NULL;
#line 158 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 158 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 158 "../src/sudoku-view.vala"
	(left_func_target_destroy_notify == NULL) ? NULL : (left_func_target_destroy_notify (left_func_target), NULL);
#line 158 "../src/sudoku-view.vala"
	left_func = NULL;
#line 158 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 158 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 158 "../src/sudoku-view.vala"
	(down_func_target_destroy_notify == NULL) ? NULL : (down_func_target_destroy_notify (down_func_target), NULL);
#line 158 "../src/sudoku-view.vala"
	down_func = NULL;
#line 158 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 158 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 158 "../src/sudoku-view.vala"
	(up_func_target_destroy_notify == NULL) ? NULL : (up_func_target_destroy_notify (up_func_target), NULL);
#line 158 "../src/sudoku-view.vala"
	up_func = NULL;
#line 158 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 158 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 3957 "sudoku-view.c"
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
#line 26 "../src/sudoku-view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 33 "../src/sudoku-view.vala"
	self->priv->_selected_row = 0;
#line 34 "../src/sudoku-view.vala"
	self->priv->_selected_col = 0;
#line 410 "../src/sudoku-view.vala"
	self->priv->_has_selection = TRUE;
#line 3972 "sudoku-view.c"
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 26 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 28 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->game);
#line 29 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 31 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->frame);
#line 32 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused_label);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 3991 "sudoku-view.c"
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (adw_bin_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_view_get_selected_row (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_view_get_selected_col (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_extra_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_has_selection (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 4068 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 4074 "sudoku-view.c"
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_selected_row (self, g_value_get_int (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_selected_col (self, g_value_get_int (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_has_selection (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 4130 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 4136 "sudoku-view.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

